﻿--[[ Postal_Wire: Update Subject Field with Money Amount if blank ]]--

assert( Postal, "Postal not found!")

------------------------------
--      Are you local?      --
------------------------------

local L = AceLibrary("AceLocale-2.2"):new("Postal")

local COPPER_ABBR = string.lower(string.sub(COPPER, 1, 1))
local SILVER_ABBR = string.lower(string.sub(SILVER, 1, 1))
local GOLD_ABBR = string.lower(string.sub(GOLD, 1, 1))
if (string.byte(COPPER_ABBR) or 128) > 127 then
	-- non-western
	COPPER_ABBR = COPPER
	SILVER_ABBR = SILVER
	GOLD_ABBR = GOLD
end
if ( GetLocale() == "zhTW" ) then
	COPPER_ABBR = "銅"
	SILVER_ABBR = "銀"
	GOLD_ABBR = "金"
elseif ( GetLocale() == "zhCN" ) then
	COPPER_ABBR = "铜"
	SILVER_ABBR = "银"
	GOLD_ABBR = "金"
end

----------------------------------
--      Module Declaration      --
----------------------------------

Postal_Wire = Postal:NewModule("Wire")
Postal_Wire.revision = tonumber(string.sub("$Revision: 55175 $", 12, -3))

function Postal_Wire:OnEnable()
	self:SecureHook(SendMailMoney, "onvalueChangedFunc")
end

function Postal_Wire:onvalueChangedFunc()
	local subject = SendMailSubjectEditBox:GetText()
	if subject == ""
	or subject:find(L["^%[%d+g %d+s %d+c%]$"])
	or subject:find(L["^%[%d+s %d+c%]$"])
	or subject:find(L["^%[%d+c%]$"]) then
		local copper = MoneyInputFrame_GetCopper(SendMailMoney)
		if copper and copper > 0 then
			SendMailSubjectEditBox:SetText("["..self:GetMoneyString(copper).."]")
		end
	end
end

function Postal_Wire:GetMoneyString(money)
	local gold = floor(money / 10000)
	local silver = floor((money - gold * 10000) / 100)
	local copper = mod(money, 100)

	if gold > 0 then
		return format("%d%s %d%s %d%s", gold, GOLD_ABBR, silver, SILVER_ABBR, copper, COPPER_ABBR)
	elseif silver > 0 then
		return format("%d%s %d%s", silver, SILVER_ABBR, copper, COPPER_ABBR)
	else
		return format("%d%s", copper, COPPER_ABBR)
	end
end
